# Full command line switch reference

note: Options which could exist without beeing documented here are considered as experimental ones. Such experimental options should usually not be used.

switch | parameter
`-a` | downmix stereo file to mono
`--abr` | average bitrate encoding
`--allshort` | use short blocks only
`--athlower` | lower the ATH
`--athonly` | ATH only
`--athshort` | ATH only for short blocks
`--athtype` | select ATH type
`-b` | bitrate (8...320)
`-B` | max VBR/ABR bitrate (8...320)
`--bitwidth` | input bit width
`-c` | copyright
`--cbr` | enforce use of constant bitrate
`--comp` | choose compression ratio
`--cwlimit` | tonality limit
`-d` | block type control
`--decode` | decoding only
`--disptime` | time between display updates
`-e` | de-emphasis (n, 5, c)
`-f` | fast mode
`-F` | strictly enforce the -b option
`--freeformat` | free format bitstream
`-h` | high quality
`--help` | help
`--highpass` | highpass filtering frequency in kHz
`--highpass-width` | width of highpass filtering in kHz
`-k` | full bandwidth
`--lowpass` | lowpass filtering frequency in kHz
`--lowpass-width` | width of lowpass filtering in kHz
`-m` | stereo mode (s, j, f, m)
`--mp1input` | MPEG Layer I input file
`--mp2input` | MPEG Layer II input file
`--mp3input` | MPEG Layer III input file
`--noath` | disable ATH
`--noasm` | disable assembly optimizations (mmx/3dnow/sse)
`--nohist` | disable histogram display
`--nores` | disable bit reservoir
`--noshort` | disable short blocks frames
`--notemp` | disable temporal masking
`-o` | non-original
`-p` | error protection
`--preset` | use built-in preset
`--alt-preset` | use updated and much higher quality "alternate" presets
`--priority` | OS/2 process priority control
`-q` | algorithm quality selection
`--quiet` | silent operation
`-r` | input file is raw pcm
`--resample` | output sampling frequency in kHz (encoding only)
`--r3mix` | r3mix VBR preset
`-s` | sampling frequency in kHz
`-S` | silent operation
`--scale` | scale input
`--scale-l` | scale input channel 0 (left)
`--scale-r` | scale input channel 1 (right)
`--short` | use short blocks
`--silent` | silent operation
`--strictly-enforce-ISO` | strict ISO compliance
`-t` | disable INFO/WAV header
`-V` | VBR quality setting (0...9)
`--vbr-new` | new VBR mode
`--vbr-old` | older VBR mode
`--verbose` | verbosity
`-x` | swapbytes
`-X` | change quality measure

* `-a` downmix
  Mix the stereo input file to mono and encode as mono.
  The downmix is calculated as the sum of the left and right channel, attenuated by 6 dB.
  This option is only needed in the case of raw PCM stereo input (because LAME cannot determine the number of channels in the input file).
  To encode a stereo PCM input file as mono, use "lame -m s -a".
  For WAV and AIFF input files, using "-m m" will always produce a mono .mp3 file from both mono and stereo input.

* `--abr n` average bitrate encoding

  Turns on encoding with a targeted average bitrate of n kbits, allowing to use frames of different sizes. The allowed range of n is 8-310, you can use any integer value within that range.
  It can be combined with the -b and -B switches like:
  lame --abr 123 -b 64 -B 192 a.wav a.mp3
  which would limit the allowed frame sizes between 64 and 192 kbits.

* `--allshort` use short blocks only

  Use only short blocks, no long ones.

* `--athlower n` lower the ATH

  Lower the ATH (absolute threshold of hearing) by n dB.
  Normally, humans are unable to hear any sound below this threshold, but for music recorded at very low level this option might be usefull.

* `--athonly` ATH only

  This option causes LAME to ignore the output of the psy-model and only use masking from the ATH (absolute threshold of hearing). Might be useful at very high bitrates or for testing the ATH.

* `--athshort` ATH only for short blocks

  Ignore psychoacoustic model for short blocks, use ATH only.

* `--athtype 0/1/2` select ATH type

  The Absolute Threshold of Hearing is the minimum threshold under which humans are unable to hear any sound. In the past, LAME was using ATH shape 0 which is the Painter & Spanias formula. Tests have shown that this formula is innacurate for the 13-22 kHz area, leading to audible artifacts in some cases. Shape 1 was thus implemented, which is over sensitive, leading to very high bitrates. Shape 2 formula was accurately modelized from real data in order to real optimal quality while not wasting bitrate. In CBR and ABR modes, LAME uses ATH shape 2 by default.
  In VBR mode, LAME is adapting its shape according to the -V value, going gradually from the 0 shape at -V9 up to shape 2 at -V0.

* `-b n` bitrate

  For MPEG1 (sampling frequencies of 32, 44.1 and 48 kHz)
  n = 32,40,48,56,64,80,96,112,128,160,192,224,256,320
  For MPEG2 (sampling frequencies of 16, 22.05 and 24 kHz)
  n = 8,16,24,32,40,48,56,64,80,96,112,128,144,160
  Default is 128 kbs for MPEG1 and 64 kbs for MPEG2.
  When used with variable bitrate encoding (VBR), -b specifies the minimum bitrate to be used. However, in order to avoid wasted space, the smallest frame size available will be used during silences.

* `-B n` maximum VBR/ABR bitrate

  For MPEG1 (sampling frequencies of 32, 44.1 and 48 kHz)
  n = 32,40,48,56,64,80,96,112,128,160,192,224,256,320
  For MPEG2 (sampling frequencies of 16, 22.05 and 24 kHz)
  n = 8,16,24,32,40,48,56,64,80,96,112,128,144,160
  Specifies the maximum allowed bitrate when using VBR/ABR
  The use of -B is NOT RECOMMENDED. A 128kbs CBR bitstream, because of the bit reservoir, can actually have frames which use as many bits as a 320kbs frame. VBR modes minimize the use of the bit reservoir, and thus need to allow 320kbs frames to get the same flexibility as CBR streams.
  note: If you own an mp3 hardware player build upon a MAS 3503 chip, you must set maximum bitrate to no more than 224 kpbs.

* `--bitwidth 8/16/24/32` input bit width

  Required only for raw PCM input files. Otherwise it will be determined from the header of the input file.

* `-c` copyright

  Mark the encoded file as being copyrighted.

* `--cbr` enforce use of constant bitrate

  This switch enforces the use of constant bitrate encoding.

* `--comp` choose compression ratio

  Instead of choosing bitrate, using this option, user can choose compression ratio to achieve.

* `--cwlimit n` tonality limit

  Compute tonality up to freq (in kHz). Default setting is 8.8717.

* `-d` block type control

  Allows the left and right channels to use different block size types.

* `--decode` decoding only

  Uses LAME for decoding to a wav file. The input file can be any input type supported by encoding, including layer I,II,III (MP3) and OGG files. In case of MPEG files, LAME uses a bugfixed version of mpglib for decoding.
  If -t is used (disable wav header), Lame will output raw pcm in native endian format. You can use -x to swap bytes order.

* `--disptime n` time between display updates

  Set the delay in seconds between two display updates.

* `-e n/5/c` de-emphasis

  n = (none, default)
  5 = 0/15 microseconds
  c = citt j.17
  All this does is set a flag in the bitstream. If you have a PCM input file where one of the above types of (obsolete) emphasis has been applied, you can set this flag in LAME. Then the mp3 decoder should de-emphasize the output during playback, although most decoders ignore this flag.
  A better solution would be to apply the de-emphasis with a standalone utility before encoding, and then encode without -e.

* `-f` fast mode

  This switch forces the encoder to use a faster encoding mode, but with a lower quality. The behaviour is the same as the -q7 switch.
  Noise shaping will be disabled, but psycho acoustics will still be computed for bit allocation and pre-echo detection.

* `-F` strictly enforce the -b option

  This is mainly for use with hardware players that do not support low bitrate mp3.
  Without this option, the minimum bitrate will be ignored for passages of analog silence, ie when the music level is below the absolute threshold of human hearing (ATH).

* `--freeformat` free format bitstream

  Produces a free format bitstream. With this option, you can use -b with any bitrate higher than 8 kbps.
  However, even if an mp3 decoder is required to support free bitrates at least up to 320 kbps, many players are unable to deal with it.
  Tests have shown that the following decoders support free format:
  FreeAmp up to 440 kbps
  in_mpg123 up to 560 kbps
  l3dec up to 310 kbps
  LAME up to 560 kbps
  MAD up to 640 kbps

* `-h` high quality

  Use some quality improvements. Encoding will be slower, but the result will be of higher quality. The behaviour is the same as the -q2 switch.
  This switch is always enabled when using VBR.

* `--help` help

  Display a list of all available options.

* `--highpass` highpass filtering frequency in kHz

  Set an highpass filtering frequency. Frequencies below the specified one will be cutoff.

* `--highpass-width` width of highpass filtering in kHz

  Set the width of the highpass filter. The default value is 15% of the highpass frequency.

* `-k` full bandwidth

  Tells the encoder to use full bandwidth and to disable all filters. By default, the encoder uses some highpass filtering at low bitrates, in order to keep a good quality by giving more bits to more important frequencies.
  Increasing the bandwidth from the default setting might produce ringing artefacts at low bitrates. Use with care!

* `--lowpass` lowpass filtering frequency in kHz

  Set a lowpass filtering frequency. Frequencies above the specified one will be cutoff.

* `--lowpass-width` width of lowpass filtering in kHz

  Set the width of the lowpass filter. The default value is 15% of the lowpass frequency.

* `-m s/j/f/d/m` stereo mode

  Joint-stereo is the default mode for stereo files with VBR when -V is more than 4 or fixed bitrates of 160kbs or less. At higher fixed bitrates or higher VBR settings, the default is stereo.
  stereo
  In this mode, the encoder makes no use of potentially existing correlations between the two input channels. It can, however, negotiate the bit demand between both channel, i.e. give one channel more bits if the other contains silence or needs less bits because of a lower complexity.
  joint stereo
  In this mode, the encoder will make use of a correlation between both channels. The signal will be matrixed into a sum ("mid"), computed by L+R, and difference ("side") signal, computed by L-R, and more bits are allocated to the mid channel.
  This will effectively increase the bandwidth if the signal does not have too much stereo separation, thus giving a significant gain in encoding quality.
  Using mid/side stereo inappropriately can result in audible compression artifacts. To much switching between mid/side and regular stereo can also sound bad. To determine when to switch to mid/side stereo, LAME uses a much more sophisticated algorithm than that described in the ISO documentation, and thus is safe to use in joint stereo mode.
  forced joint stereo
  This mode will force MS joint stereo on all frames. It's slightly faster than joint stereo, but it should be used only if you are sure that every frame of the input file has very little stereo separation.
  dual channels
  In this mode, the 2 channels will be totally indenpendently encoded. Each channel will have exactly half of the bitrate. This mode is designed for applications like dual languages encoding (ex: English in one channel and French in the other). Using this encoding mode for regular stereo files will result in a lower quality encoding.
  mono
  The input will be encoded as a mono signal. If it was a stereo signal, it will be downsampled to mono. The downmix is calculated as the sum of the left and right channel, attenuated by 6 dB.

* `--mp1input` MPEG Layer I input file

  Assume the input file is a MPEG Layer I file.
  If the filename ends in ".mp1" or ".mpg" LAME will assume it is a MPEG Layer I file. For stdin or Layer I files which do not end in .mp1 or .mpg you need to use this switch.

* `--mp2input` MPEG Layer II input file

  Assume the input file is a MPEG Layer II (ie MP2) file.
  If the filename ends in ".mp2" LAME will assume it is a MPEG Layer II file. For stdin or Layer II files which do not end in .mp2 you need to use this switch.

* `--mp3input` MPEG Layer III input file

  Assume the input file is a MP3 file. Usefull for downsampling from one mp3 to another. As an example, it can be usefull for streaming through an IceCast server.
  If the filename ends in ".mp3" LAME will assume it is an MP3 file. For stdin or MP3 files which do not end in .mp3 you need to use this switch.

* `--noath` disable ATH

  Disable any use of the ATH (absolute threshold of hearing) for masking. Normally, humans are unable to hear any sound below this threshold.

* `--noasm mmx/3dnow/sse` disable assembly optimisations

  Disable specific assembly optimizations. Quality will not increase, only speed will be reduced. If you have problems running Lame on a Cyrix/Via processor, disabling mmx optimizations might solve your problem.

* `--nohist` disable histogram display

  By default, LAME will display a bitrate histogram while producing VBR mp3 files. This will disable that feature.
  Histogram display might not be available on your release.

* `--nores` disable bit reservoir

  Disable the bit reservoir. Each frame will then become independent from previous ones, but the quality will be lower.

* `--noshort` disable short blocks frames

  Encode all frames using long blocks only. This could increase quality when encoding at very low bitrates, but can produce serious pre-echo artefacts.

* `--notemp` disable temporal masking

  Don't make use of the temporal masking effect.

* `-o` non-original

  Mark the encoded file as being a copy.

* `-p` error protection

  Turn on CRC error protection.
  It will add a cyclic redundancy check (CRC) code in each frame, allowing to detect transmission errors that could occur on the MP3 stream. However, it takes 16 bits per frame that would otherwise be used for encoding, and then will slightly reduce the sound quality.

* `--preset presetName` use built-in preset

  Use one of the built-in presets (phone, phon+, lw, mw-eu, mw-us, sw, fm, voice, radio, tape, hifi, cd, studio).
  "--preset help" gives more information about the used options in these presets.

* `--alt-preset presetName` use updated and much higher quality "alternate" presets
  Use one of the built-in alternate presets (standard, fast standard, extreme, fast extreme, insane, or the abr/cbr modes).
  "--alt-preset help" gives more information about the usage possibilities for these presets.

* `--priority 0...4` OS/2 process priority control

  With this option, LAME will run with a different process priority under IBM OS/2.
  This will greatly improve system responsiveness, since OS/2 will have more free time to properly update the screen and poll the keyboard/mouse. It should make quite a difference overall, especially on slower machines. LAME's performance impact should be minimal.
  0 (Low priority)
  Priority 0 assumes "IDLE" class, with delta 0.
  LAME will have the lowest priority possible, and the encoding may be suspended very frequently by user interaction.
  1 (Medium priority)
  Priority 1 assumes "IDLE" class, with delta +31.
  LAME won't interfere at all with what you're doing.
  Recommended if you have a slower machine.
  2 (Regular priority)
  Priority 2 assumes "REGULAR" class, with delta -31.
  LAME won't interfere with your activity. It'll run just like a regular process, but will spare just a bit of idle time for the system. Recommended for most users.
  3 (High priority)
  Priority 3 assumes "REGULAR" class, with delta 0.
  LAME will run with a priority a bit higher than a normal process.
  Good if you're just running LAME by itself or with moderate user interaction.
  4 (Maximum priority)
  Priority 4 assumes "REGULAR" class, with delta +31.
  LAME will run with a very high priority, and may interfere with the machine response.
  Recommended if you only intend to run LAME by itself, or if you have a fast processor.
  Priority 1 or 2 is recommended for most users.

* `-q 0..9` algorithm quality selection

  Bitrate is of course the main influence on quality. The higher the bitrate, the higher the quality. But for a given bitrate, we have a choice of algorithms to determine the best scalefactors and huffman encoding (noise shaping).
  -q 0: use slowest & best possible version of all algorithms. -q 0 and -q 1 are slow and may not produce significantly higher quality.
  -q 2: recommended. Same as -h.
  -q 5: default value. Good speed, reasonable quality.
  -q 7: same as -f. Very fast, ok quality. (psycho acoustics are used for pre-echo & M/S, but no noise shaping is done.
  -q 9: disables almost all algorithms including psy-model. poor quality.

* `-r` input file is raw pcm

  Assume the input file is raw pcm. Sampling rate and mono/stereo/jstereo must be specified on the command line. Without -r, LAME will perform several fseek()'s on the input file looking for WAV and AIFF headers.
  Might not be available on your release.

* `--resample 8/11.025/12/16/22.05/24/32/44.1/48` output sampling frequency in kHz

  Select ouptut sampling frequency (for encoding only).
  If not specified, LAME will automatically resample the input when using high compression ratios.

* `--r3mix` r3mix VBR preset

  Uses r3mix VBR preset.
  See www.r3mix.net for more details.

* `-s 8/11.025/12/16/22.05/24/32/44.1/48` sampling frequency

  Required only for raw PCM input files. Otherwise it will be determined from the header of the input file.
  LAME will automatically resample the input file to one of the supported MP3 samplerates if necessary.

* `-S / --silent / --quiet` silent operation

  Don't print progress report.

* `--scale n` scales input by n
* `--scale-l n` scales input channel 0 (left) by n
* `--scale-r n` scales input channel 1 (right) by n

  Scales input by n. This just multiplies the PCM data (after it has been converted to floating point) by n.
  n > 1: increase volume
  n = 1: no effect
  n < 1: reduce volume
  Use with care, since most MP3 decoders will truncate data which decodes to values greater than 32768.

* `--short` use short blocks

  Let LAME use short blocks when appropriate. It is the default setting.

* `--strictly-enforce-ISO` strict ISO compliance

  With this option, LAME will enforce the 7680 bit limitation on total frame size.
  This results in many wasted bits for high bitrate encodings but will ensure strict ISO compatibility. This compatibility might be important for hardware players.

* `-t` disable INFO/WAV header

  Disable writing of the INFO Tag on encoding.
  This tag in embedded in frame 0 of the MP3 file. It includes some information about the encoding options of the file, and in VBR it lets VBR aware players correctly seek and compute playing times of VBR files.
  When '--decode' is specified (decode to WAV), this flag will disable writing of the WAV header. The output will be raw pcm, native endian format. Use -x to swap bytes.

* `-V 0...9` VBR quality setting

  Enable VBR (Variable BitRate) and specifies the value of VBR quality.
  default=4
  0=highest quality.

* `--vbr-new` new VBR mode

  Invokes the newest VBR algorithm. During the development of version 3.90, considerable tuning was done on this algorithm, and it is now considered to be on par with the original --vbr-old.
  It has the added advantage of being very fast (over twice as fast as --vbr-old).

* `--vbr-old` older VBR mode

  Invokes the oldest, most tested VBR algorithm. It produces very good quality files, though is not very fast. This has, up through v3.89, been considered the "workhorse" VBR algorithm.

* `--verbose` verbosity

  Print a lot of information on screen.

* `-x` swapbytes

  Swap bytes in the input file or ouptut file when using --decode.
  For sorting out little endian/big endian type problems. If your encodings sounds like static, try this first.

* `-X 0...7` change quality measure

  When LAME searches for a "good" quantization, it has to compare the actual one with the best one found so far. The comparison says which one is better, the best so far or the actual. The -X parameter selects between different approaches to make this decision, -X0 beeing the default mode:
  -X0
  The criterions are (in order of importance):
  * less distorted scalefactor bands
  * the sum of noise over the thresholds is lower
  * the total noise is lower
  -X1
  The actual is better if the maximum noise over all scalefactor bands is less than the best so far .
  -X2
  The actual is better if the total sum of noise is lower than the best so far.
  -X3
  The actual is better if the total sum of noise is lower than the best so far and the maximum noise over all scalefactor bands is less than the best so far plus 2db.
  -X4
  Not yet documented.
  -X5
  The criterions are (in order of importance):
  * the sum of noise over the thresholds is lower
  * the total sum of noise is lower
  -X6
  The criterions are (in order of importance):
  * the sum of noise over the thresholds is lower
  * the maximum noise over all scalefactor bands is lower
  * the total sum of noise is lower
  -X7
  The criterions are:
  * less distorted scalefactor bands
  or
  * the sum of noise over the thresholds is lower